(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('micro-dash')) :
    typeof define === 'function' && define.amd ? define('s-js-utils', ['exports', 'micro-dash'], factory) :
    (global = global || self, factory(global['s-js-utils'] = {}, global.microDash));
}(this, function (exports, microDash) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Returns whether `set` contains all the elements in `subset`. Taken from https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Set.
     *
     * ```ts
     * const setA = new Set([1, 2, 3, 4]);
     * const setB = new Set([3, 4]);
     * setUnion(setA, setB); // true
     * ```
     * @param {?} set
     * @param {?} subset
     * @return {?}
     */
    function isSuperset(set, subset) {
        var e_1, _a;
        try {
            for (var subset_1 = __values(subset), subset_1_1 = subset_1.next(); !subset_1_1.done; subset_1_1 = subset_1.next()) {
                var elem = subset_1_1.value;
                if (!set.has(elem)) {
                    return false;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (subset_1_1 && !subset_1_1.done && (_a = subset_1.return)) _a.call(subset_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return true;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} setA
     * @param {?} setB
     * @return {?}
     */
    function isSetEqual(setA, setB) {
        return setA.size === setB.size && isSuperset(setA, setB);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Returns a new set that contains the elements of `setA` that are not in `setB`. Taken from https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Set.
     *
     * ```ts
     * const setA = new Set([1, 2, 3, 4]);
     * const setB = new Set([3, 4, 5, 6]);
     * setDifference(setA, setB); // Set [1, 2]
     * ```
     * @template T
     * @param {?} setA
     * @param {?} setB
     * @return {?}
     */
    function setDifference(setA, setB) {
        var e_1, _a;
        /** @type {?} */
        var difference = new Set(setA);
        try {
            for (var setB_1 = __values(setB), setB_1_1 = setB_1.next(); !setB_1_1.done; setB_1_1 = setB_1.next()) {
                var elem = setB_1_1.value;
                difference.delete(elem);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (setB_1_1 && !setB_1_1.done && (_a = setB_1.return)) _a.call(setB_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return difference;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Returns a new set that contains the elements that are in both `setA` and `setB`. Taken from https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Set.
     *
     * ```ts
     * const setA = new Set([1, 2, 3, 4]);
     * const setB = new Set([3, 4, 5, 6]);
     * setIntersection(setA, setB); // Set [3, 4]
     * ```
     * @template T
     * @param {?} setA
     * @param {?} setB
     * @return {?}
     */
    function setIntersection(setA, setB) {
        var e_1, _a;
        /** @type {?} */
        var intersection = new Set();
        try {
            for (var setB_1 = __values(setB), setB_1_1 = setB_1.next(); !setB_1_1.done; setB_1_1 = setB_1.next()) {
                var elem = setB_1_1.value;
                if (setA.has(elem)) {
                    intersection.add(elem);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (setB_1_1 && !setB_1_1.done && (_a = setB_1.return)) _a.call(setB_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return intersection;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Returns a new set that contains the elements that are in either `setA` or `setB`. Taken from https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Set.
     *
     * ```ts
     * const setA = new Set([1, 2, 3, 4]);
     * const setB = new Set([3, 4, 5, 6]);
     * setUnion(setA, setB); // Set [1, 2, 3, 4, 5, 6]
     * ```
     * @template T
     * @param {?} setA
     * @param {?} setB
     * @return {?}
     */
    function setUnion(setA, setB) {
        var e_1, _a;
        /** @type {?} */
        var union = new Set(setA);
        try {
            for (var setB_1 = __values(setB), setB_1_1 = setB_1.next(); !setB_1_1.done; setB_1_1 = setB_1.next()) {
                var elem = setB_1_1.value;
                if (!setA.has(elem)) {
                    union.add(elem);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (setB_1_1 && !setB_1_1.done && (_a = setB_1.return)) _a.call(setB_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return union;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Returns a new set that contains the elements that are in only one of the two sets. Taken from https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Set.
     *
     * ```ts
     * const setA = new Set([1, 2, 3, 4]);
     * const setB = new Set([3, 4, 5, 6]);
     * symmetricSetDifference(setA, setB); // Set [1, 2, 5, 6]
     * ```
     * @template T
     * @param {?} setA
     * @param {?} setB
     * @return {?}
     */
    function symmetricSetDifference(setA, setB) {
        var e_1, _a;
        /** @type {?} */
        var difference = new Set(setA);
        try {
            for (var setB_1 = __values(setB), setB_1_1 = setB_1.next(); !setB_1_1.done; setB_1_1 = setB_1.next()) {
                var elem = setB_1_1.value;
                if (difference.has(elem)) {
                    difference.delete(elem);
                }
                else {
                    difference.add(elem);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (setB_1_1 && !setB_1_1.done && (_a = setB_1.return)) _a.call(setB_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return difference;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Extend this for classes whose objects are directly callable. Sadly, you'll need to define an extra interface and repeat the typing information, for now. (Maybe fixable with TypeScript 3 tuples?)
     *
     * ```ts
     * interface Multiplier {
     *   (value: number): number;
     * }
     *
     * class Multiplier extends CallableObject {
     *   constructor(public factor: number) {
     *     super((value: number) => value * this.factor);
     *   }
     * }
     *
     * const doubler = new Multiplier(2);
     * doubler(2); // 4
     * doubler.factor = 3;
     * doubler(2); // 6
     * ```
     * @abstract
     */
    var   /**
     * Extend this for classes whose objects are directly callable. Sadly, you'll need to define an extra interface and repeat the typing information, for now. (Maybe fixable with TypeScript 3 tuples?)
     *
     * ```ts
     * interface Multiplier {
     *   (value: number): number;
     * }
     *
     * class Multiplier extends CallableObject {
     *   constructor(public factor: number) {
     *     super((value: number) => value * this.factor);
     *   }
     * }
     *
     * const doubler = new Multiplier(2);
     * doubler(2); // 4
     * doubler.factor = 3;
     * doubler(2); // 6
     * ```
     * @abstract
     */
    CallableObject = /** @class */ (function () {
        function CallableObject(f) {
            var _newTarget = this.constructor;
            return Object.setPrototypeOf(f, _newTarget.prototype);
        }
        return CallableObject;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var seq = 0;
    /**
     * Creates a factory function for building objects of a given type. Commonly used to create test objects for use in specs.
     *
     * ```ts
     * interface Message {
     *   id: number;
     *   text: string;
     * }
     *
     * interface Options {
     *   cypherDistance: number;
     * }
     *
     * declare function shiftCharacters(text: string, distance: number): string;
     *
     * const buildMessage = createBuilder<Message, Options>(
     *   (seq) => ({ id: seq, text: `message ${seq}` }),
     *   (message, _seq, options) => {
     *     message.text = shiftCharacters(message.text, options.cypherDistance || 0);
     *   },
     * );
     *
     * buildMessage(); // { id: 1, text: "message 1" }
     * buildMessage({ text: "Hello world!" }); // { id: 2, text: "Hello world!" }
     * buildMessage({ text: "abc" }, { cypherDistance: 3 }); // { id: 3, text: "def" }
     * ```
     * @template T, OptionsType
     * @param {?} buildDefaults
     * @param {?=} afterBuild
     * @return {?}
     */
    function createBuilder(buildDefaults, afterBuild) {
        return (/**
         * @param {?=} attributes
         * @param {?=} options
         * @return {?}
         */
        function (attributes, options) {
            if (options === void 0) { options = {}; }
            ++seq;
            /** @type {?} */
            var obj = Object.assign(buildDefaults(seq, options), attributes);
            if (afterBuild) {
                afterBuild(obj, seq, options);
            }
            return obj;
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Returns a new function to use in place of `func` that will call the provided hooks in addition to `func`. They are called in the following order:
     *
     * 1. `before`
     * 2. `around` if provided, else `original`
     * 3. `transform`
     * 4. `after`
     *
     * ```ts
     * const sum = (a: number, b: number) => a + b;
     * const sumAndLog = wrapFunction(sum, {
     *   after: (result, a, b) => {
     *     console.log(a, '+', b, '=', result);
     *   },
     * }
     * const sumPlusOne = wrapFunction(sum, {
     *   transform: (result) => result + 1,
     * });
     * ```
     * @template A, R, T
     * @param {?} original
     * @param {?} __1
     * @return {?}
     */
    function wrapFunction(original, _a) {
        var before = _a.before, around = _a.around, transform = _a.transform, after = _a.after;
        /** @type {?} */
        var wrapped = (/**
         * @this {?}
         * @param {...?} args
         * @return {?}
         */
        function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            if (before) {
                before.apply(this, args);
            }
            /** @type {?} */
            var result;
            if (around) {
                result = ((/** @type {?} */ (around))).call.apply(((/** @type {?} */ (around))), __spread([this, original], args));
            }
            else {
                result = original.apply(this, args);
            }
            if (transform) {
                result = ((/** @type {?} */ (transform))).call.apply(((/** @type {?} */ (transform))), __spread([this, result], args));
            }
            if (after) {
                ((/** @type {?} */ (after))).call.apply(((/** @type {?} */ (after))), __spread([this, result], args));
            }
            return result;
        });
        Object.defineProperty(wrapped, "length", { value: original.length });
        return wrapped;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * An object you can use to create a promise and resolve/reject it later.
     *
     * ```ts
     * const deferred = new Deferred<string>();
     *
     * // later
     * deferred.resolve('a nice value'); // causes `deferred.promise` to resolve
     *
     * // or
     * deferred.reject('a bad value'); // causes `deferred.promise` to reject
     * ```
     * @template T
     */
    var   /**
     * An object you can use to create a promise and resolve/reject it later.
     *
     * ```ts
     * const deferred = new Deferred<string>();
     *
     * // later
     * deferred.resolve('a nice value'); // causes `deferred.promise` to resolve
     *
     * // or
     * deferred.reject('a bad value'); // causes `deferred.promise` to reject
     * ```
     * @template T
     */
    Deferred = /** @class */ (function () {
        function Deferred() {
            var _this = this;
            this.pending = true;
            /** @type {?} */
            var hooks = {
                before: (/**
                 * @return {?}
                 */
                function () {
                    _this.pending = false;
                }),
            };
            this.promise = new Promise((/**
             * @param {?} resolve
             * @param {?} reject
             * @return {?}
             */
            function (resolve, reject) {
                _this.resolve = wrapFunction(resolve, hooks);
                _this.reject = wrapFunction(reject, hooks);
            }));
        }
        /**
         * @return {?}
         */
        Deferred.prototype.isPending = /**
         * @return {?}
         */
        function () {
            return this.pending;
        };
        return Deferred;
    }());
    if (false) {
        /** @type {?} */
        Deferred.prototype.promise;
        /** @type {?} */
        Deferred.prototype.resolve;
        /** @type {?} */
        Deferred.prototype.reject;
        /**
         * @type {?}
         * @private
         */
        Deferred.prototype.pending;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} collection
     * @param {?} iteratee
     * @param {?=} accumulator
     * @return {?}
     */
    function forEachWithObject(collection, iteratee, accumulator) {
        if (accumulator === void 0) { accumulator = {}; }
        microDash.forEach(collection, (/**
         * @param {?} value
         * @param {?} keyOrIndex
         * @return {?}
         */
        function (value, keyOrIndex) {
            iteratee(accumulator, value, keyOrIndex);
        }));
        return accumulator;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Checks if `value` is anything other than `undefined`.
     *
     * ```ts
     * isDefined({ a: 1 }); // true
     * isDefined(false); // true
     * isDefined(null); // true
     * isDefined(undefined); // false
     * ```
     * @param {?} value
     * @return {?}
     */
    function isDefined(value) {
        return !microDash.isUndefined(value);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Performs a deep comparison between two values to determine if they are equivalent, up to the given depth. Once that depth is reached, remaining values are compared using `Object.is()`.
     *
     * ```ts
     * let object1 = "a";
     * let object2 = "a";
     * isEqualAtDepth(0, object1, object2); // true
     * isEqualAtDepth(1, object1, object2); // true
     *
     * let object1 = { a: 1 };
     * let object2 = { a: 1 };
     * isEqualAtDepth(0, object1, object2); // false
     * isEqualAtDepth(1, object1, object2); // true
     *
     * object1 = { a: [1, 2, 3], d: { e: 1 } };
     * object2 = { a: [1, 2, 3], d: { e: 1 } };
     * isEqualAtDepth(0, object1, object2); // false
     * isEqualAtDepth(1, object1, object2); // false
     * isEqualAtDepth(2, object1, object2); // true
     * isEqualAtDepth(3, object1, object2); // true
     * ```
     * @param {?} depth
     * @param {?} value
     * @param {?} other
     * @return {?}
     */
    function isEqualAtDepth(depth, value, other) {
        var e_1, _a, e_2, _b;
        if (Object.is(value, other)) {
            // covers e.g. NaN === NaN
            return true;
        }
        if (depth === 0 || !(value instanceof Object && other instanceof Object)) {
            return false;
        }
        try {
            for (var _c = __values(microDash.keys(value)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var key = _d.value;
                if (!other.hasOwnProperty(key)) {
                    return false;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
        try {
            for (var _e = __values(microDash.keys(other)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var key = _f.value;
                if (!isEqualAtDepth(depth - 1, value[key], other[key])) {
                    return false;
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return true;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} collection
     * @param {?} iteratee
     * @return {?}
     */
    function mapToObject(collection, iteratee) {
        return forEachWithObject(collection, (/**
         * @param {?} accumulator
         * @param {?} origValue
         * @param {?} keyOrIndex
         * @return {?}
         */
        function (accumulator, origValue, keyOrIndex) {
            var _a = __read(iteratee(origValue, keyOrIndex), 2), key = _a[0], newValue = _a[1];
            accumulator[key] = newValue;
        }));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} collection
     * @param {?} iteratee
     * @return {?}
     */
    function mapAsKeys(collection, iteratee) {
        return mapToObject(collection, (/**
         * @param {?} value
         * @param {?} keyOrIndex
         * @return {?}
         */
        function (value, keyOrIndex) { return [
            value,
            iteratee(value, keyOrIndex),
        ]; }));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Rounds `value` to the nearest multiple of `multiple`.
     *
     * ```ts
     * roundToMultiple(5, 13); // 15
     * roundToMultiple(2, 4.8); // 4
     * roundToMultiple(3, -4); // -3
     * roundToMultiple(0.5, 1.6); // 1.5
     * ```
     * @param {?} multiple
     * @param {?} value
     * @return {?}
     */
    function roundToMultipleOf(multiple, value) {
        return Math.round(value / multiple) * multiple;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Returns a promise that resolves after `ms` milliseconds.
     *
     * ```ts
     * // do something
     * await sleep(1000); // wait a second
     * // do something else
     * ```
     * @param {?} ms
     * @return {?}
     */
    function sleep(ms) {
        return new Promise((/**
         * @param {?} resolve
         * @return {?}
         */
        function (resolve) {
            setTimeout(resolve, ms);
        }));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var nanoConversions = {};
    /** @enum {string} */
    var TimeUnit = {
        Nanoseconds: "ns",
        Microseconds: "μs",
        Milliseconds: "ms",
        Seconds: "s",
        Minutes: "m",
        Hours: "h",
        Days: "d",
        Weeks: "w",
        Years: "y",
        Decades: "dec",
        Centuries: "cent",
        Millennia: "mil",
    };
    /**
     * Converts time between two units. Units can be any value described in the docs for [[TimeUnit]].
     *
     * ```ts
     * convertTime(1, 's', 'ms'); // 1000
     * convertTime(20, TimeUnit.Decades, TimeUnit.Centuries); // 2
     * ```
     * @param {?} value
     * @param {?} unit
     * @param {?} targetUnit
     * @return {?}
     */
    function convertTime(value, unit, targetUnit) {
        return (value * nanoConversions[unit]) / nanoConversions[targetUnit];
    }
    /**
     * Constructs a string representation of an elapsed amount of time. The least significant unit will be rounded to the nearest whole number.
     *
     * ```ts
     * elapsedToString(2001, ["s", "ms"]); // "2 s 1 ms"
     * elapsedToString(15, ["wks", "d"], ( elapsedUnit: TimeUnit.Days }); // "2 wks 1 d"
     * elapsedToString(1, [TimeUnit.Microseconds]); // "1000 μs"
     * ```
     *
     * @param {?} elapsed
     * @param {?} units
     * @param {?=} __2
     * @return {?}
     */
    function elapsedToString(elapsed, units, _a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.elapsedUnit, elapsedUnit = _c === void 0 ? TimeUnit.Milliseconds : _c, _d = _b.showLeadingZeros, showLeadingZeros = _d === void 0 ? true : _d;
        elapsed = roundToMultipleOf(convertTime(1, microDash.last(units), elapsedUnit), elapsed);
        /** @type {?} */
        var showZeros = showLeadingZeros;
        /** @type {?} */
        var tokens = [];
        for (var i = 0; i < units.length; ++i) {
            /** @type {?} */
            var unit = units[i];
            /** @type {?} */
            var conversion = convertTime(1, elapsedUnit, unit);
            /** @type {?} */
            var value = Math.floor(elapsed * conversion);
            if (value > 0 || showZeros || i === units.length - 1) {
                tokens.push(value);
                tokens.push(unit);
                showZeros = true;
            }
            elapsed -= value / conversion;
        }
        return tokens.join(" ");
    }
    addConversion(TimeUnit.Nanoseconds, "Nanosecond", 1, { aliases: ["nanos"] });
    addConversion(TimeUnit.Microseconds, "Microsecond", 1000, {
        aliases: ["micros"],
    });
    addConversion(TimeUnit.Milliseconds, "Millisecond", 1000 * 1000, {
        aliases: ["millis"],
    });
    addConversion(TimeUnit.Seconds, "Second", 1000 * 1000 * 1000, {
        aliases: ["S", "sec", "secs"],
    });
    addConversion(TimeUnit.Minutes, "Minute", 60 * 1000 * 1000 * 1000, {
        aliases: ["M", "min", "mins"],
    });
    addConversion(TimeUnit.Hours, "Hour", 60 * 60 * 1000 * 1000 * 1000, {
        aliases: ["H", "hr", "hrs"],
    });
    addConversion(TimeUnit.Days, "Day", 24 * 60 * 60 * 1000 * 1000 * 1000, {
        aliases: ["D"],
    });
    addConversion(TimeUnit.Weeks, "Week", 7 * 24 * 60 * 60 * 1000 * 1000 * 1000, {
        aliases: ["W", "wk", "wks"],
    });
    addConversion(TimeUnit.Years, "Year", 365 * 24 * 60 * 60 * 1000 * 1000 * 1000, {
        aliases: ["Y", "yr", "yrs"],
    });
    addConversion(TimeUnit.Decades, "Decade", 10 * 365 * 24 * 60 * 60 * 1000 * 1000 * 1000);
    addConversion(TimeUnit.Centuries, "Century", 100 * 365 * 24 * 60 * 60 * 1000 * 1000 * 1000, { plural: "Centuries" });
    addConversion(TimeUnit.Millennia, "Millennium", 1000 * 365 * 24 * 60 * 60 * 1000 * 1000 * 1000, { plural: "Millennia" });
    /**
     * @param {?} unit
     * @param {?} singular
     * @param {?} nanos
     * @param {?=} __3
     * @return {?}
     */
    function addConversion(unit, singular, nanos, _a) {
        var e_1, _b;
        var _c = _a === void 0 ? {} : _a, _d = _c.aliases, aliases = _d === void 0 ? (/** @type {?} */ ([])) : _d, _e = _c.plural, plural = _e === void 0 ? singular + "s" : _e;
        try {
            for (var _f = __values(__spread([
                unit,
                singular,
                singular.toLowerCase(),
                plural,
                plural.toLowerCase()
            ], aliases)), _g = _f.next(); !_g.done; _g = _f.next()) {
                var key = _g.value;
                nanoConversions[key] = nanos;
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
            }
            finally { if (e_1) throw e_1.error; }
        }
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Converts a 2D array to a csv string. Values are converted using micro-dash's toString().
     *
     * ```ts
     * toCsv([["a", "b", "c"], ["d", "e", "f"], ["g", "h", "i"]]); // "a,b,c\nd,e,f\ng,h,i"
     * toCsv([
     *   ["a", "", "string"]
     *   [undefined, null],
     *   [true, false],
     *   [1, 2, 3],
     *   [{}, { hi: "there" }]
     * ]) // "a,,string\n,\ntrue,false\n1,2,3\n[object Object],[object Object]"
     * ```
     * @param {?} content
     * @return {?}
     */
    function toCsv(content) {
        return content
            .map((/**
         * @param {?} row
         * @return {?}
         */
        function (row) { return row.map((/**
         * @param {?} cell
         * @return {?}
         */
        function (cell) { return toCellString(cell); })).join(","); }))
            .join("\n");
    }
    /** @type {?} */
    var specialCsvCharactersRegexp = /["|,|\n|\r]/;
    /** @type {?} */
    var allDoubleQuotes = /"/g;
    /**
     * @param {?} value
     * @return {?}
     */
    function toCellString(value) {
        /** @type {?} */
        var str = microDash.toString(value);
        if (specialCsvCharactersRegexp.test(str)) {
            return "\"" + str.replace(allDoubleQuotes, "\"\"") + "\"";
        }
        else {
            return str;
        }
    }

    exports.CallableObject = CallableObject;
    exports.Deferred = Deferred;
    exports.TimeUnit = TimeUnit;
    exports.convertTime = convertTime;
    exports.createBuilder = createBuilder;
    exports.elapsedToString = elapsedToString;
    exports.forEachWithObject = forEachWithObject;
    exports.isDefined = isDefined;
    exports.isEqualAtDepth = isEqualAtDepth;
    exports.isSetEqual = isSetEqual;
    exports.isSuperset = isSuperset;
    exports.mapAsKeys = mapAsKeys;
    exports.mapToObject = mapToObject;
    exports.roundToMultipleOf = roundToMultipleOf;
    exports.setDifference = setDifference;
    exports.setIntersection = setIntersection;
    exports.setUnion = setUnion;
    exports.sleep = sleep;
    exports.symmetricSetDifference = symmetricSetDifference;
    exports.toCsv = toCsv;
    exports.wrapFunction = wrapFunction;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=s-js-utils.umd.js.map
